=== modified file 'client/drizzleslap.cc'
--- client/drizzleslap.cc	2011-08-12 16:41:20 +0000
+++ client/drizzleslap.cc	2011-11-30 17:23:18 +0000
@@ -72,13 +72,13 @@
 */
 
 #include <config.h>
-#include "client_priv.h"
+#include "client/client_priv.h"
 
-#include "option_string.h"
-#include "stats.h"
-#include "thread_context.h"
-#include "conclusions.h"
-#include "wakeup.h"
+#include "client/option_string.h"
+#include "client/stats.h"
+#include "client/thread_context.h"
+#include "client/conclusions.h"
+#include "client/wakeup.h"
 
 #include <signal.h>
 #include <stdarg.h>

=== modified file 'client/include.am'
--- client/include.am	2011-11-22 15:31:32 +0000
+++ client/include.am	2011-11-30 17:23:18 +0000
@@ -17,12 +17,12 @@
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 
-CLIENT_LDADD= \
-	      drizzled/internal/libinternal.la \
-	      libdrizzle-2.0/libdrizzle-2.0.la \
-	      $(LIBINTL) \
-	      $(LIBZ) \
-	      client/libgetpassword.la
+CLIENT2_LDADD= \
+	       drizzled/internal/libinternal.la \
+	       libdrizzle-2.0/libdrizzle-2.0.la \
+	       $(LIBINTL) \
+	       $(LIBZ) \
+	       client/libgetpassword.la
 
 noinst_LTLIBRARIES+= \
 		     client/libgetpassword.la
@@ -77,14 +77,14 @@
 			    client/drizzledump_mysql.cc \
 			    client/server_detect.cc
 
-client_drizzledump_LDADD=	${CLIENT_LDADD} ${BOOST_LIBS}
+client_drizzledump_LDADD=	${CLIENT2_LDADD} ${BOOST_LIBS}
 
 client_drizzleimport_SOURCES=	client/drizzleimport.cc
-client_drizzleimport_LDADD=	${CLIENT_LDADD} ${BOOST_LIBS}
+client_drizzleimport_LDADD=	${CLIENT2_LDADD} ${BOOST_LIBS}
 
 client_drizzleslap_SOURCES=	client/drizzleslap.cc
-client_drizzleslap_LDADD=	${CLIENT_LDADD} ${BOOST_LIBS}
+client_drizzleslap_LDADD=	${CLIENT2_LDADD} ${BOOST_LIBS}
 client_drizzleslap_CXXFLAGS=	${AM_CXXFLAGS} ${BOOSTSKIP_WARNINGS}
 
 client_drizzletest_SOURCES=	client/drizzletest.cc
-client_drizzletest_LDADD=	${CLIENT_LDADD} ${BOOST_LIBS} ${LIBPCRE} 
+client_drizzletest_LDADD=	${CLIENT2_LDADD} ${BOOST_LIBS} ${LIBPCRE} 

=== renamed file 'libdrizzle-1.0/column.c' => 'libdrizzle-1.0/column.cc'
--- libdrizzle-1.0/column.c	2011-11-07 15:04:16 +0000
+++ libdrizzle-1.0/column.cc	2011-11-30 17:23:18 +0000
@@ -356,7 +356,7 @@
 {
   if (column == NULL)
   {
-    column= malloc(sizeof(drizzle_column_st));
+    column= new (std::nothrow) (drizzle_column_st);
     if (column == NULL)
     {
       drizzle_set_error(result->con->drizzle, "drizzle_column_create",
@@ -377,8 +377,8 @@
     column->charset = 0;
     column->size = 0;
     column->max_size = 0;
-    column->type = 0;
-    column->flags = 0;
+    column->type = drizzle_column_type_t();
+    column->flags = drizzle_column_flags_t();
     column->decimals = 0;
     /* UNSET: column->default_value */
     column->default_value_size = 0;
@@ -389,7 +389,7 @@
     column->result = result;
     /* SET BELOW: column->next */
     column->prev = NULL;
-    column->options= 0;
+    column->options= drizzle_column_options_t();
     column->catalog[0] = '\0';
     column->db[0] = '\0';
     column->table[0] = '\0';
@@ -399,8 +399,8 @@
     column->charset = 0;
     column->size = 0;
     column->max_size = 0;
-    column->type = 0;
-    column->flags = 0;
+    column->type = drizzle_column_type_t();
+    column->flags = drizzle_column_flags_t();
     column->decimals = 0;
     /* UNSET: column->default_value */
     column->default_value_size = 0;
@@ -426,7 +426,9 @@
     column->next->prev= column->prev;
 
   if (column->options & DRIZZLE_COLUMN_ALLOCATED)
-    free(column);
+  {
+    delete [] column;
+  }
 }
 
 drizzle_result_st *drizzle_column_drizzle_result(drizzle_column_st *column)
@@ -497,7 +499,7 @@
 
 drizzle_column_flags_t drizzle_column_flags(drizzle_column_st *column)
 {
-  return column->flags;
+  return drizzle_column_flags_t(column->flags);
 }
 
 uint8_t drizzle_column_decimals(drizzle_column_st *column)
@@ -521,13 +523,13 @@
   drizzle_return_t ret;
   if (drizzle_state_none(result->con))
   {
-    result->options|= DRIZZLE_RESULT_SKIP_COLUMN;
+    result->options|= int(DRIZZLE_RESULT_SKIP_COLUMN);
 
     drizzle_state_push(result->con, drizzle_state_column_read);
     drizzle_state_push(result->con, drizzle_state_packet_read);
   }
   ret= drizzle_state_loop(result->con);
-  result->options&= ~DRIZZLE_RESULT_SKIP_COLUMN;
+  result->options&= ~int(DRIZZLE_RESULT_SKIP_COLUMN);
   return ret;
 }
 
@@ -570,16 +572,15 @@
   {
     if (result->column_count == 0)
     {
-      result->options|= DRIZZLE_RESULT_BUFFER_COLUMN;
+      result->options|= int(DRIZZLE_RESULT_BUFFER_COLUMN);
       return DRIZZLE_RETURN_OK;
     }
 
-    result->column_buffer= malloc(sizeof(drizzle_column_st) *
-                                  result->column_count);
+    result->column_buffer= new (std::nothrow) drizzle_column_st[result->column_count];
     if (result->column_buffer == NULL)
     {
-      drizzle_set_error(result->con->drizzle, "drizzle_column_buffer",
-                        "malloc");
+      drizzle_set_error(result->con->drizzle, __func__, "malloc");
+
       return DRIZZLE_RETURN_MEMORY;
     }
   }
@@ -795,7 +796,7 @@
     /* EOF packet marking end of columns. */
     con->result->column= NULL;
     con->result->warning_count= drizzle_get_byte2(con->buffer_ptr + 1);
-    con->status= drizzle_get_byte2(con->buffer_ptr + 3);
+    con->status= drizzle_con_status_t(drizzle_get_byte2(con->buffer_ptr + 3));
     con->buffer_ptr+= 5;
     con->buffer_size-= 5;
 
@@ -835,20 +836,22 @@
     column->size= drizzle_get_byte4(con->buffer_ptr + 3);
 
     if (con->options & DRIZZLE_CON_MYSQL)
-      column->type= con->buffer_ptr[7];
+    {
+      column->type= drizzle_column_type_t(con->buffer_ptr[7]);
+    }
     else
     {
-      drizzle_type= con->buffer_ptr[7];
+      drizzle_type= drizzle_column_type_drizzle_t(con->buffer_ptr[7]);
       if (drizzle_type >= DRIZZLE_COLUMN_TYPE_DRIZZLE_MAX)
         drizzle_type= DRIZZLE_COLUMN_TYPE_DRIZZLE_MAX;
       column->type= _column_type_drizzle_map_to[drizzle_type];
     }
 
-    column->flags= drizzle_get_byte2(con->buffer_ptr + 8);
+    column->flags= drizzle_column_flags_t(drizzle_get_byte2(con->buffer_ptr + 8));
     if (column->type <= DRIZZLE_COLUMN_TYPE_INT24 &&
         column->type != DRIZZLE_COLUMN_TYPE_TIMESTAMP)
     {
-      column->flags|= DRIZZLE_COLUMN_FLAGS_NUM;
+      column->flags|= int(DRIZZLE_COLUMN_FLAGS_NUM);
     }
 
     column->decimals= con->buffer_ptr[10];

=== modified file 'libdrizzle-1.0/column.h'
--- libdrizzle-1.0/column.h	2011-11-04 21:06:16 +0000
+++ libdrizzle-1.0/column.h	2011-11-30 17:23:18 +0000
@@ -40,8 +40,7 @@
  * @brief Column Declarations
  */
 
-#ifndef __DRIZZLE_COLUMN_H
-#define __DRIZZLE_COLUMN_H
+#pragma once
 
 #ifdef __cplusplus
 extern "C" {
@@ -174,5 +173,3 @@
 #ifdef __cplusplus
 }
 #endif
-
-#endif /* __DRIZZLE_COLUMN_H */

=== renamed file 'libdrizzle-1.0/command.c' => 'libdrizzle-1.0/command.cc'
=== modified file 'libdrizzle-1.0/command_client.h'
--- libdrizzle-1.0/command_client.h	2011-11-04 21:06:16 +0000
+++ libdrizzle-1.0/command_client.h	2011-11-30 17:23:18 +0000
@@ -39,8 +39,7 @@
  * @brief Command Declarations for Clients
  */
 
-#ifndef __DRIZZLE_COMMAND_CLIENT_H
-#define __DRIZZLE_COMMAND_CLIENT_H
+#pragma once
 
 #ifdef __cplusplus
 extern "C" {
@@ -60,5 +59,3 @@
 #ifdef __cplusplus
 }
 #endif
-
-#endif /* __DRIZZLE_COMMAND_CLIENT_H */

=== modified file 'libdrizzle-1.0/command_server.h'
--- libdrizzle-1.0/command_server.h	2011-11-04 21:06:16 +0000
+++ libdrizzle-1.0/command_server.h	2011-11-30 17:23:18 +0000
@@ -40,8 +40,7 @@
  * @brief Command Declarations for Servers
  */
 
-#ifndef __DRIZZLE_COMMAND_SERVER_H
-#define __DRIZZLE_COMMAND_SERVER_H
+#pragma once
 
 #ifdef __cplusplus
 extern "C" {
@@ -60,5 +59,3 @@
 #ifdef __cplusplus
 }
 #endif
-
-#endif /* __DRIZZLE_COMMAND_SERVER_H */

=== modified file 'libdrizzle-1.0/common.h'
--- libdrizzle-1.0/common.h	2011-11-07 15:04:16 +0000
+++ libdrizzle-1.0/common.h	2011-11-30 17:23:18 +0000
@@ -65,3 +65,5 @@
 #include <libdrizzle-1.0/pack.h>
 #include <libdrizzle-1.0/state.h>
 #include <libdrizzle-1.0/sha1.h>
+
+#include <memory>

=== renamed file 'libdrizzle-1.0/conn.c' => 'libdrizzle-1.0/conn.cc'
--- libdrizzle-1.0/conn.c	2011-11-07 15:04:16 +0000
+++ libdrizzle-1.0/conn.cc	2011-11-30 17:23:18 +0000
@@ -89,7 +89,7 @@
   (void)closesocket(con->fd);
   con->fd= -1;
 
-  con->options&= (drizzle_con_options_t)~DRIZZLE_CON_READY;
+  con->options&= int(~DRIZZLE_CON_READY);
   con->packet_number= 0;
   con->buffer_ptr= con->buffer;
   con->buffer_size= 0;
@@ -179,7 +179,7 @@
 
 drizzle_con_options_t drizzle_con_options(const drizzle_con_st *con)
 {
-  return con->options;
+  return drizzle_con_options_t(con->options);
 }
 
 void drizzle_con_set_options(drizzle_con_st *con,
@@ -196,7 +196,7 @@
   /* If asking for the experimental Drizzle protocol, clean the MySQL flag. */
   if (con->options & DRIZZLE_CON_EXPERIMENTAL)
   {
-    con->options&= (drizzle_con_options_t)~DRIZZLE_CON_MYSQL;
+    con->options&= int(~DRIZZLE_CON_MYSQL);
   }
 }
 
@@ -356,7 +356,7 @@
 
 drizzle_capabilities_t drizzle_con_capabilities(const drizzle_con_st *con)
 {
-  return con->capabilities;
+  return drizzle_capabilities_t(con->capabilities);
 }
 
 drizzle_charset_t drizzle_con_charset(const drizzle_con_st *con)
@@ -654,7 +654,7 @@
   drizzle_con_set_server_version(con, from->server_version);
   drizzle_con_set_thread_id(con, from->thread_id);
   drizzle_con_set_scramble(con, from->scramble);
-  drizzle_con_set_capabilities(con, from->capabilities);
+  drizzle_con_set_capabilities(con, drizzle_capabilities_t(from->capabilities));
   drizzle_con_set_charset(con, from->charset);
   drizzle_con_set_status(con, from->status);
   drizzle_con_set_max_packet_size(con, from->max_packet_size);
@@ -692,11 +692,10 @@
                                  drizzle_command_t *command, size_t *total,
                                  drizzle_return_t *ret_ptr)
 {
-  uint8_t *command_data;
   size_t offset= 0;
   size_t size= 0;
 
-  command_data= drizzle_con_command_read(con, command, &offset, &size, total, ret_ptr);
+  char *command_data= (char *)drizzle_con_command_read(con, command, &offset, &size, total, ret_ptr);
   if (*ret_ptr != DRIZZLE_RETURN_OK)
     return NULL;
 
@@ -708,7 +707,7 @@
 
   if (con->command_buffer == NULL)
   {
-    con->command_buffer= malloc((*total) + 1);
+    con->command_buffer= (uint8_t*)malloc((*total) + 1);
     if (con->command_buffer == NULL)
     {
       drizzle_set_error(con->drizzle, "drizzle_command_buffer", "malloc");
@@ -721,15 +720,14 @@
 
   while ((offset + size) != (*total))
   {
-    command_data= drizzle_con_command_read(con, command, &offset, &size, total,
-                                           ret_ptr);
+    command_data= (char *)drizzle_con_command_read(con, command, &offset, &size, total, ret_ptr);
     if (*ret_ptr != DRIZZLE_RETURN_OK)
       return NULL;
 
     memcpy(con->command_buffer + offset, command_data, size);
   }
 
-  command_data= con->command_buffer;
+  command_data= (char *)con->command_buffer;
   con->command_buffer= NULL;
   command_data[*total]= 0;
 
@@ -1219,7 +1217,6 @@
 {
   char host[NI_MAXHOST];
   char port[NI_MAXSERV];
-  int ret;
   int fd;
   int opt;
   drizzle_con_st *new_con;
@@ -1227,13 +1224,12 @@
   for (; con->addrinfo_next != NULL;
        con->addrinfo_next= con->addrinfo_next->ai_next)
   {
-    ret= getnameinfo(con->addrinfo_next->ai_addr,
-                     con->addrinfo_next->ai_addrlen, host, NI_MAXHOST, port,
-                     NI_MAXSERV, NI_NUMERICHOST | NI_NUMERICSERV);
+    int ret= getnameinfo(con->addrinfo_next->ai_addr,
+                         con->addrinfo_next->ai_addrlen, host, NI_MAXHOST, port,
+                         NI_MAXSERV, NI_NUMERICHOST | NI_NUMERICSERV);
     if (ret != 0)
     {
-      drizzle_set_error(con->drizzle, "drizzle_state_listen", "getnameinfo:%s",
-                        gai_strerror(ret));
+      drizzle_set_error(con->drizzle, "drizzle_state_listen", "getnameinfo:%s", gai_strerror(ret));
       return DRIZZLE_RETURN_GETADDRINFO;
     }
 
@@ -1307,11 +1303,11 @@
     }
 
     /* Wait for read events on the listening socket. */
-    ret= drizzle_con_set_events(new_con, POLLIN);
-    if (ret != DRIZZLE_RETURN_OK)
+    drizzle_return_t local_ret= drizzle_con_set_events(new_con, POLLIN);
+    if (local_ret != DRIZZLE_RETURN_OK)
     {
       drizzle_con_free(new_con);
-      return ret;
+      return local_ret;
     }
 
     drizzle_log_info(con->drizzle, "listening on %s:%s", host, port);

=== renamed file 'libdrizzle-1.0/conn_uds.c' => 'libdrizzle-1.0/conn_uds.cc'
=== renamed file 'libdrizzle-1.0/drizzle.c' => 'libdrizzle-1.0/drizzle.cc'
--- libdrizzle-1.0/drizzle.c	2011-11-07 15:04:16 +0000
+++ libdrizzle-1.0/drizzle.cc	2011-11-30 17:23:18 +0000
@@ -101,7 +101,7 @@
 
   if (drizzle == NULL)
   {
-    drizzle= malloc(sizeof(drizzle_st));
+    drizzle= new (std::nothrow) drizzle_st;
     if (drizzle == NULL)
       return NULL;
 
@@ -145,7 +145,7 @@
   if (drizzle == NULL)
     return NULL;
 
-  drizzle->options|= (from->options & (drizzle_options_t)~DRIZZLE_ALLOCATED);
+  drizzle->options|= (from->options & int(~DRIZZLE_ALLOCATED));
 
   for (con= from->con_list; con != NULL; con= con->next)
   {
@@ -207,7 +207,7 @@
 
 drizzle_options_t drizzle_options(const drizzle_st *drizzle)
 {
-  return drizzle->options;
+  return drizzle_options_t(drizzle->options);
 }
 
 void drizzle_set_options(drizzle_st *drizzle, drizzle_options_t options)
@@ -280,7 +280,7 @@
 {
   if (con == NULL)
   {
-    con= malloc(sizeof(drizzle_con_st));
+    con= new (std::nothrow) drizzle_con_st;
     if (con == NULL)
     {
       if (drizzle != NULL)
@@ -307,7 +307,7 @@
   con->revents= 0;
   con->capabilities= DRIZZLE_CAPABILITIES_NONE;
   con->charset= 0;
-  con->command= 0;
+  con->command= drizzle_command_t();
   con->options|= DRIZZLE_CON_MYSQL;
   con->socket_type= DRIZZLE_CON_SOCKET_TCP;
   con->status= DRIZZLE_CON_STATUS_NONE;
@@ -356,10 +356,10 @@
     return NULL;
 
   /* Clear "operational" options such as IO status. */
-  con->options|= (from->options & (drizzle_con_options_t)~(
+  con->options|= (from->options & int(~(
                   DRIZZLE_CON_ALLOCATED|DRIZZLE_CON_READY|
                   DRIZZLE_CON_NO_RESULT_READ|DRIZZLE_CON_IO_READY|
-                  DRIZZLE_CON_LISTEN));
+                  DRIZZLE_CON_LISTEN)));
   con->backlog= from->backlog;
   strcpy(con->db, from->db);
   strcpy(con->password, from->password);
@@ -512,7 +512,7 @@
   {
     if (con->options & DRIZZLE_CON_IO_READY)
     {
-      con->options&= (drizzle_con_options_t)~DRIZZLE_CON_IO_READY;
+      con->options&= int(~DRIZZLE_CON_IO_READY);
       return con;
     }
   }
@@ -532,7 +532,7 @@
     if ((con->options & (DRIZZLE_CON_IO_READY | DRIZZLE_CON_LISTEN)) ==
         (DRIZZLE_CON_IO_READY | DRIZZLE_CON_LISTEN))
     {
-      con->options&= (drizzle_con_options_t)~DRIZZLE_CON_IO_READY;
+      con->options&= int(~DRIZZLE_CON_IO_READY);
       return con;
     }
   }
@@ -595,7 +595,7 @@
 
   drizzle_con_set_tcp(con, host, port);
   drizzle_con_set_backlog(con, backlog);
-  drizzle_con_add_options(con, DRIZZLE_CON_LISTEN | options);
+  drizzle_con_add_options(con, drizzle_con_options_t(DRIZZLE_CON_LISTEN | int(options)));
 
   return con;
 }
@@ -611,7 +611,7 @@
 
   drizzle_con_set_uds(con, uds);
   drizzle_con_set_backlog(con, backlog);
-  drizzle_con_add_options(con, DRIZZLE_CON_LISTEN | options);
+  drizzle_con_add_options(con, drizzle_con_options_t(DRIZZLE_CON_LISTEN | int(options)));
 
   return con;
 }
@@ -677,12 +677,11 @@
 {
   size_t size;
   int written;
-  char *ptr;
   char log_buffer[DRIZZLE_MAX_ERROR_SIZE];
   va_list args;
 
   size= strlen(function);
-  ptr= memcpy(log_buffer, function, size);
+  char *ptr= (char *)memcpy(log_buffer, function, size);
   ptr+= size;
   ptr[0]= ':';
   size++;

=== renamed file 'libdrizzle-1.0/field.c' => 'libdrizzle-1.0/field.cc'
--- libdrizzle-1.0/field.c	2011-11-07 15:04:16 +0000
+++ libdrizzle-1.0/field.cc	2011-11-30 17:23:18 +0000
@@ -93,7 +93,7 @@
 
   if (result->field_buffer == NULL)
   {
-    result->field_buffer= malloc((*total) + 1);
+    result->field_buffer= (drizzle_field_t)malloc((*total) + 1);
     if (result->field_buffer == NULL)
     {
       drizzle_set_error(result->con->drizzle, "drizzle_field_buffer", "malloc");
@@ -139,7 +139,7 @@
   {
     if (result->options & DRIZZLE_RESULT_ROW_BREAK)
     {
-      result->options&= (drizzle_result_options_t)~DRIZZLE_RESULT_ROW_BREAK;
+      result->options&= int(~DRIZZLE_RESULT_ROW_BREAK);
       result->field= field;
       result->field_size= size;
     }

=== renamed file 'libdrizzle-1.0/handshake.c' => 'libdrizzle-1.0/handshake.cc'
--- libdrizzle-1.0/handshake.c	2011-11-07 15:04:16 +0000
+++ libdrizzle-1.0/handshake.cc	2011-11-30 17:23:18 +0000
@@ -142,7 +142,7 @@
   }
 
   /* Look for null-terminated server version string. */
-  ptr= memchr(con->buffer_ptr, 0, con->buffer_size - 1);
+  ptr= (uint8_t*)memchr(con->buffer_ptr, 0, con->buffer_size - 1);
   if (ptr == NULL)
   {
     drizzle_set_error(con->drizzle, "drizzle_state_handshake_server_read",
@@ -188,7 +188,7 @@
   con->charset= con->buffer_ptr[0];
   con->buffer_ptr+= 1;
 
-  con->status= drizzle_get_byte2(con->buffer_ptr);
+  con->status= drizzle_con_status_t(drizzle_get_byte2(con->buffer_ptr));
   /* Skip status and filler. */
   con->buffer_ptr+= 15;
 
@@ -325,7 +325,6 @@
 drizzle_return_t drizzle_state_handshake_client_read(drizzle_con_st *con)
 {
   size_t real_size;
-  uint8_t *ptr;
   uint8_t scramble_size;
 
   drizzle_log_debug(con->drizzle, "drizzle_state_handshake_client_read");
@@ -368,7 +367,7 @@
   con->buffer_ptr+= 23;
 
   /* Look for null-terminated user string. */
-  ptr= memchr(con->buffer_ptr, 0, con->buffer_size - 32);
+  uint8_t *ptr= (uint8_t*)memchr(con->buffer_ptr, 0, con->buffer_size - 32);
   if (ptr == NULL)
   {
     drizzle_set_error(con->drizzle, "drizzle_state_handshake_client_read",
@@ -401,7 +400,9 @@
   con->buffer_ptr+= 1;
 
   if (scramble_size == 0)
+  {
     con->scramble= NULL;
+  }
   else
   {
     if (scramble_size != DRIZZLE_MAX_SCRAMBLE_SIZE)
@@ -420,10 +421,12 @@
 
   /* Look for null-terminated db string. */
   if ((34 + strlen(con->user) + scramble_size) == con->packet_size)
+  {
     con->db[0]= 0;
+  }
   else
   {
-    ptr= memchr(con->buffer_ptr, 0, con->buffer_size -
+    ptr= (uint8_t*)memchr(con->buffer_ptr, 0, con->buffer_size -
                                     (34 + strlen(con->user) + scramble_size));
     if (ptr == NULL)
     {
@@ -470,7 +473,7 @@
 drizzle_return_t drizzle_state_handshake_client_write(drizzle_con_st *con)
 {
   uint8_t *ptr;
-  drizzle_capabilities_t capabilities;
+  int capabilities;
   drizzle_return_t ret;
 
   drizzle_log_debug(con->drizzle, "drizzle_state_handshake_client_write");
@@ -503,28 +506,28 @@
   if (con->options & DRIZZLE_CON_MYSQL)
     con->capabilities|= DRIZZLE_CAPABILITIES_PROTOCOL_41;
 
-  capabilities= con->capabilities & DRIZZLE_CAPABILITIES_CLIENT;
+  capabilities= con->capabilities & int(DRIZZLE_CAPABILITIES_CLIENT);
   if (!(con->options & DRIZZLE_CON_FOUND_ROWS))
-    capabilities&= ~DRIZZLE_CAPABILITIES_FOUND_ROWS;
+    capabilities&= ~int(DRIZZLE_CAPABILITIES_FOUND_ROWS);
 
   if (con->options & DRIZZLE_CON_INTERACTIVE)
   {
-    capabilities|= DRIZZLE_CAPABILITIES_INTERACTIVE;
+    capabilities|= int(DRIZZLE_CAPABILITIES_INTERACTIVE);
   }
 
   if (con->options & DRIZZLE_CON_MULTI_STATEMENTS)
   {
-    capabilities|= DRIZZLE_CAPABILITIES_MULTI_STATEMENTS;
+    capabilities|= int(DRIZZLE_CAPABILITIES_MULTI_STATEMENTS);
   }
 
   if (con->options & DRIZZLE_CON_AUTH_PLUGIN)
   {
-    capabilities|= DRIZZLE_CAPABILITIES_PLUGIN_AUTH;
+    capabilities|= int(DRIZZLE_CAPABILITIES_PLUGIN_AUTH);
   }
 
-  capabilities&= ~(DRIZZLE_CAPABILITIES_COMPRESS | DRIZZLE_CAPABILITIES_SSL);
+  capabilities&= ~(int(DRIZZLE_CAPABILITIES_COMPRESS) | int(DRIZZLE_CAPABILITIES_SSL));
   if (con->db[0] == 0)
-    capabilities&= ~DRIZZLE_CAPABILITIES_CONNECT_WITH_DB;
+    capabilities&= ~int(DRIZZLE_CAPABILITIES_CONNECT_WITH_DB);
 
   drizzle_set_byte4(ptr, capabilities);
   ptr+= 4;

=== modified file 'libdrizzle-1.0/include.am'
--- libdrizzle-1.0/include.am	2011-11-22 15:31:32 +0000
+++ libdrizzle-1.0/include.am	2011-11-30 17:23:18 +0000
@@ -36,10 +36,9 @@
 
 lib_LTLIBRARIES+= libdrizzle-1.0/libdrizzle.la
 
-libdrizzle_1_0_libdrizzle_la_CFLAGS= \
-				     ${AM_CFLAGS} \
-				     ${CFLAG_VISIBILITY} \
-				     -DBUILDING_LIBDRIZZLE
+libdrizzle_1_0_libdrizzle_la_CXXFLAGS= \
+				       ${CFLAG_VISIBILITY} \
+				       -DBUILDING_LIBDRIZZLE
 
 libdrizzle_1_0_libdrizzle_la_LDFLAGS= \
 				      $(AM_LDFLAGS) \
@@ -48,19 +47,19 @@
 				      $(OLDLIBDRIZZLE_LIBRARY_VERSION)
 
 libdrizzle_1_0_libdrizzle_la_SOURCES= \
-				      libdrizzle-1.0/column.c \
-				      libdrizzle-1.0/command.c \
-				      libdrizzle-1.0/conn.c \
-				      libdrizzle-1.0/conn_uds.c \
-				      libdrizzle-1.0/drizzle.c \
-				      libdrizzle-1.0/field.c \
-				      libdrizzle-1.0/handshake.c \
-				      libdrizzle-1.0/pack.c \
-				      libdrizzle-1.0/query.c \
-				      libdrizzle-1.0/result.c \
-				      libdrizzle-1.0/row.c \
-				      libdrizzle-1.0/sha1.c \
-				      libdrizzle-1.0/state.c
+				      libdrizzle-1.0/column.cc \
+				      libdrizzle-1.0/command.cc \
+				      libdrizzle-1.0/conn.cc \
+				      libdrizzle-1.0/conn_uds.cc \
+				      libdrizzle-1.0/drizzle.cc \
+				      libdrizzle-1.0/field.cc \
+				      libdrizzle-1.0/handshake.cc \
+				      libdrizzle-1.0/pack.cc \
+				      libdrizzle-1.0/query.cc \
+				      libdrizzle-1.0/result.cc \
+				      libdrizzle-1.0/row.cc \
+				      libdrizzle-1.0/sha1.cc \
+				      libdrizzle-1.0/state.cc
 
 nobase_include_HEADERS+= \
 			 libdrizzle-1.0/column.h \

=== renamed file 'libdrizzle-1.0/pack.c' => 'libdrizzle-1.0/pack.cc'
=== renamed file 'libdrizzle-1.0/query.c' => 'libdrizzle-1.0/query.cc'
--- libdrizzle-1.0/query.c	2011-11-07 15:04:16 +0000
+++ libdrizzle-1.0/query.cc	2011-11-30 17:23:18 +0000
@@ -97,7 +97,7 @@
 {
   if (query == NULL)
   {
-    query= malloc(sizeof(drizzle_query_st));
+    query= new (std::nothrow) drizzle_query_st;
     if (query == NULL)
     {
       drizzle_set_error(drizzle, "drizzle_query_create", "malloc");
@@ -181,7 +181,7 @@
 
 drizzle_query_options_t drizzle_query_options(drizzle_query_st *query)
 {
-  return query->options;
+  return drizzle_query_options_t(query->options);
 }
 
 void drizzle_query_set_options(drizzle_query_st *query,
@@ -259,7 +259,7 @@
 drizzle_query_st *drizzle_query_run(drizzle_st *drizzle,
                                     drizzle_return_t *ret_ptr)
 {
-  drizzle_options_t options;
+  int options;
   drizzle_query_st *query;
   drizzle_con_st *con;
 
@@ -269,8 +269,8 @@
     return NULL;
   }
 
-  options= drizzle->options;
-  drizzle->options|= DRIZZLE_NON_BLOCKING;
+  options= int(drizzle->options);
+  drizzle->options|= int(DRIZZLE_NON_BLOCKING);
 
   /* Check to see if any queries need to be started. */
   if (drizzle->query_new > 0)
@@ -290,7 +290,7 @@
       {
         assert(query->state == DRIZZLE_QUERY_STATE_DONE);
         drizzle->query_running--;
-        drizzle->options= options;
+        drizzle->options= int(options);
         query->con->query= NULL;
         if (*ret_ptr == DRIZZLE_RETURN_ERROR_CODE || *ret_ptr == DRIZZLE_RETURN_OK)
         {

=== modified file 'libdrizzle-1.0/query.h'
--- libdrizzle-1.0/query.h	2011-11-04 21:06:16 +0000
+++ libdrizzle-1.0/query.h	2011-11-30 17:23:18 +0000
@@ -39,8 +39,7 @@
  * @brief Query Declarations
  */
 
-#ifndef __DRIZZLE_QUERY_H
-#define __DRIZZLE_QUERY_H
+#pragma once
 
 #ifdef __cplusplus
 extern "C" {
@@ -241,5 +240,3 @@
 #ifdef __cplusplus
 }
 #endif
-
-#endif /* __DRIZZLE_QUERY_H */

=== renamed file 'libdrizzle-1.0/result.c' => 'libdrizzle-1.0/result.cc'
--- libdrizzle-1.0/result.c	2011-11-07 23:34:24 +0000
+++ libdrizzle-1.0/result.cc	2011-11-30 17:23:18 +0000
@@ -55,7 +55,7 @@
 
   if (result == NULL)
   {
-    result= malloc(sizeof(drizzle_result_st));
+    result= new drizzle_result_st;
     if (result == NULL)
     {
       drizzle_set_error(con->drizzle, "drizzle_result_create", "malloc");
@@ -93,8 +93,7 @@
     return NULL;
   }
 
-  result->options|= (from->options &
-                     (drizzle_result_options_t)~DRIZZLE_RESULT_ALLOCATED);
+  result->options|= (from->options & ~int(DRIZZLE_RESULT_ALLOCATED));
 
   drizzle_result_set_info(result, from->info);
   result->error_code= from->error_code;
@@ -352,9 +351,7 @@
 
     if (result->row_list_size < result->row_count)
     {
-      row_list= realloc(result->row_list, sizeof(drizzle_row_t) *
-                        ((size_t)(result->row_list_size) +
-                         DRIZZLE_ROW_GROW_SIZE));
+      row_list= (drizzle_row_t *)realloc(result->row_list, sizeof(drizzle_row_t) * ((size_t)(result->row_list_size) + DRIZZLE_ROW_GROW_SIZE));
       if (row_list == NULL)
       {
         drizzle_row_free(result, row);
@@ -365,9 +362,7 @@
 
       result->row_list= row_list;
 
-      field_sizes_list= realloc(result->field_sizes_list, sizeof(size_t *) *
-                                ((size_t)(result->row_list_size) +
-                                 DRIZZLE_ROW_GROW_SIZE));
+      field_sizes_list= (size_t **)realloc(result->field_sizes_list, sizeof(size_t *) * ((size_t)(result->row_list_size) + DRIZZLE_ROW_GROW_SIZE));
       if (field_sizes_list == NULL)
       {
         drizzle_row_free(result, row);
@@ -472,7 +467,7 @@
   if (is_eof)
     result->options|= DRIZZLE_RESULT_EOF_PACKET;
   else
-    result->options&= (drizzle_result_options_t)~DRIZZLE_RESULT_EOF_PACKET;
+    result->options&= ~int(DRIZZLE_RESULT_EOF_PACKET);
 }
 
 void drizzle_result_set_info(drizzle_result_st *result, const char *info)
@@ -605,7 +600,7 @@
     /* We can ignore the returns since we've buffered the entire packet. */
     con->result->affected_rows= drizzle_unpack_length(con, &ret);
     con->result->insert_id= drizzle_unpack_length(con, &ret);
-    con->status= drizzle_get_byte2(con->buffer_ptr);
+    con->status= drizzle_con_status_t(drizzle_get_byte2(con->buffer_ptr));
     con->result->warning_count= drizzle_get_byte2(con->buffer_ptr + 2);
     con->buffer_ptr+= 4;
     con->buffer_size-= 5;
@@ -623,7 +618,7 @@
   {
     con->result->options= DRIZZLE_RESULT_EOF_PACKET;
     con->result->warning_count= drizzle_get_byte2(con->buffer_ptr + 1);
-    con->status= drizzle_get_byte2(con->buffer_ptr + 3);
+    con->status= drizzle_con_status_t(drizzle_get_byte2(con->buffer_ptr + 3));
     con->buffer_ptr+= 5;
     con->buffer_size-= 5;
     con->packet_size-= 5;

=== modified file 'libdrizzle-1.0/result.h'
--- libdrizzle-1.0/result.h	2011-11-04 21:06:16 +0000
+++ libdrizzle-1.0/result.h	2011-11-30 17:23:18 +0000
@@ -39,8 +39,7 @@
  * @brief Result Declarations
  */
 
-#ifndef __DRIZZLE_RESULT_H
-#define __DRIZZLE_RESULT_H
+#pragma once
 
 #ifdef __cplusplus
 extern "C" {
@@ -153,5 +152,3 @@
 #ifdef __cplusplus
 }
 #endif
-
-#endif /* __DRIZZLE_RESULT_H */

=== renamed file 'libdrizzle-1.0/row.c' => 'libdrizzle-1.0/row.cc'
--- libdrizzle-1.0/row.c	2011-11-07 15:04:16 +0000
+++ libdrizzle-1.0/row.cc	2011-11-30 17:23:18 +0000
@@ -77,8 +77,7 @@
     if (drizzle_row_read(result, ret_ptr) == 0 || *ret_ptr != DRIZZLE_RETURN_OK)
       return NULL;
 
-    result->row= malloc((sizeof(drizzle_field_t) + sizeof(size_t)) *
-                        result->column_count);
+    result->row= (drizzle_row_t)malloc((sizeof(drizzle_field_t) + sizeof(size_t)) * result->column_count);
     if (result->row == NULL)
     {
       drizzle_set_error(result->con->drizzle, "drizzle_row_buffer", "malloc");
@@ -203,7 +202,7 @@
     /* Got EOF packet, no more rows. */
     con->result->row_current= 0;
     con->result->warning_count= drizzle_get_byte2(con->buffer_ptr + 1);
-    con->status= drizzle_get_byte2(con->buffer_ptr + 3);
+    con->status= drizzle_con_status_t(drizzle_get_byte2(con->buffer_ptr + 3));
     con->buffer_ptr+= 5;
     con->buffer_size-= 5;
   }
@@ -214,7 +213,9 @@
     return DRIZZLE_RETURN_OK;
   }
   else if (con->result->options & DRIZZLE_RESULT_ROW_BREAK)
-    con->result->options&= (drizzle_result_options_t)~DRIZZLE_RESULT_ROW_BREAK;
+  {
+    con->result->options&= ~int(DRIZZLE_RESULT_ROW_BREAK);
+  }
   else
   {
     con->result->row_count++;

=== renamed file 'libdrizzle-1.0/sha1.c' => 'libdrizzle-1.0/sha1.cc'
=== renamed file 'libdrizzle-1.0/state.c' => 'libdrizzle-1.0/state.cc'
=== modified file 'libdrizzle-1.0/structs.h'
--- libdrizzle-1.0/structs.h	2011-11-04 21:06:16 +0000
+++ libdrizzle-1.0/structs.h	2011-11-30 17:23:18 +0000
@@ -39,8 +39,7 @@
  * @brief Struct Definitions
  */
 
-#ifndef __DRIZZLE_STRUCTS_H
-#define __DRIZZLE_STRUCTS_H
+#pragma once
 
 #include <sys/types.h>
 
@@ -58,7 +57,7 @@
 struct drizzle_st
 {
   uint16_t error_code;
-  drizzle_options_t options;
+  int options;
   drizzle_verbose_t verbose;
   uint32_t con_count;
   uint32_t pfds_size;
@@ -110,10 +109,10 @@
   uint8_t state_current;
   short events;
   short revents;
-  drizzle_capabilities_t capabilities;
+  int capabilities;
   drizzle_charset_t charset;
   drizzle_command_t command;
-  drizzle_con_options_t options;
+  int options;
   drizzle_con_socket_t socket_type;
   drizzle_con_status_t status;
   uint32_t max_packet_size;
@@ -162,7 +161,7 @@
   drizzle_st *drizzle;
   drizzle_query_st *next;
   drizzle_query_st *prev;
-  drizzle_query_options_t options;
+  int options;
   drizzle_query_state_t state;
   drizzle_con_st *con;
   drizzle_result_st *result;
@@ -180,7 +179,7 @@
   drizzle_con_st *con;
   drizzle_result_st *next;
   drizzle_result_st *prev;
-  drizzle_result_options_t options;
+  int options;
 
   char info[DRIZZLE_MAX_INFO_SIZE];
   uint16_t error_code;
@@ -220,7 +219,7 @@
   drizzle_result_st *result;
   drizzle_column_st *next;
   drizzle_column_st *prev;
-  drizzle_column_options_t options;
+  int options;
   char catalog[DRIZZLE_MAX_CATALOG_SIZE];
   char db[DRIZZLE_MAX_DB_SIZE];
   char table[DRIZZLE_MAX_TABLE_SIZE];
@@ -231,7 +230,7 @@
   uint32_t size;
   size_t max_size;
   drizzle_column_type_t type;
-  drizzle_column_flags_t flags;
+  int flags;
   uint8_t decimals;
   uint8_t default_value[DRIZZLE_MAX_DEFAULT_VALUE_SIZE];
   size_t default_value_size;
@@ -240,5 +239,3 @@
 #ifdef __cplusplus
 }
 #endif
-
-#endif /* __DRIZZLE_STRUCTS_H */

=== modified file 'libdrizzle-1.0/visibility.h'
--- libdrizzle-1.0/visibility.h	2011-11-04 21:06:16 +0000
+++ libdrizzle-1.0/visibility.h	2011-11-30 17:23:18 +0000
@@ -41,8 +41,7 @@
  * @brief Visibility Control Macros
  */
 
-#ifndef __DRIZZLE_VISIBILITY_H
-#define __DRIZZLE_VISIBILITY_H
+#pragma once
 
 /**
  *
@@ -77,5 +76,3 @@
 # endif /* defined(_MSC_VER) */
 #endif /* defined(BUILDING_LIBDRIZZLE) */
 #endif /* _WIN32 */
-
-#endif /* __DRIZZLE_VISIBILITY_H */

